#include "config.h"
#include "adc.h"
#include "dac.h"
#include "uart.h"
#include "timer.h"
#include <stdio.h>
#include <math.h>

#define TEST_LEN 128

uint32_t samples[TEST_LEN];
uint32_t mean;
uint32_t stdev;

/* Read TEST_LEN samples and compute mean & stdev. */
void test_adc(void)
{
	uint32_t tmp = 0;
	int i;

	for (i = 0; i < TEST_LEN; i++) {
		samples[i] = adc_read();
		tmp += samples[i];
	}

	mean = tmp / TEST_LEN;

	tmp = 0;
	for (i = 0; i < TEST_LEN; i++)
		tmp += (samples[i] - mean) * (samples[i] - mean);
	stdev = sqrt(tmp);
}

int main(void)
{
	int32_t i;
	int32_t j;
	config_init();
	uart1_init(115200);
	tmr1_init();
	tmr1_wait_ms(100);

	adc_init();
	dac_init();
	uart1_put_string("ADC/DAC test\r\n");

top:
	for (i = 0; i < 32768; i ++) {
		dac_write(i);
		tmr1_wait_ms(1);
		for (j = 0; j < TEST_LEN; j++) {
			uart1_put_dec(i);
			uart1_put(' ');
			uart1_put_dec(adc_convert(adc_read()));
			uart1_put_string("\r\n");
		}
	}

	uart1_put_string("-----\r\n");
	goto top;
	
	return 0;
}
